#include <iostream>
#include <string>

#include <libxml/parser.h>

using namespace std;

class Config{
    public:
	Config(char *configfile);
	~Config();

    private:
	static void startElem(void *ctx ATTRIBUTE_UNUSED, const xmlChar *name, const xmlChar **atts);
	
	void	aborter();
	
	xmlSAXHandler	SAXHandler;
};


void Config::aborter(){
	cerr<<"aborter:\n";
	throw 3;
}

void Config::startElem(void *ctx ATTRIBUTE_UNUSED, const xmlChar *name, const xmlChar **atts)
{
    Config *object=(Config *)ctx;
    cerr << "object = " << object << endl;

    
    object->aborter();
}


Config::Config(char *configfile)
{

    xmlInitParser();
    
    memset((void *)&SAXHandler,0,sizeof(xmlSAXHandler)); //cleanup handler structure

    SAXHandler.startElement=&Config::startElem;
    
    cerr << "this = " << this << endl;
    if (xmlSAXUserParseFile(&SAXHandler,this,"colorifer.xml")<0){
	    throw 3;
    }
}

Config::~Config(){
    xmlCleanupParser();
}


int main(int argc,char *argv[])
{
    try{
	Config conf("../data/colorifer.xml");
    }catch(...){
	std::cerr<<"bug\n";
    }
}
